Library ObjArrayDemo;
//*********************************************//
//                                             //
//  trueSpace eXtension                        //
//                                             //
//*********************************************//

uses Classes,
  SysUtils,
  windows,
  tsxTypes,
  tsxPluginHelper,
  Main in 'Main.pas' {frmMain},
  About in 'About.pas' {frmAbout},
  tsxObjectClass in 'tsxObjectClass.pas',
  Progress in 'Progress.pas' {frmProgress};

{$E tsx}

//toolbar button and help string resources for this plugin
{$R Array.RES}

procedure OnGetData(var tsxPlugReturn : integer);
//this procedure is called on extension intialization
//Generally just used to provide a button graphic and
//Help Text string to trueSpace.
begin
  //Change these to suit your extension
  tSXPluginHost.Title       := 'Object Array';
  tSXPluginHost.Author      := 'Leverage Data Systems, Inc.';
  //These are the resource IDs of any bitmap and string resource
  //IDB_DEFAULT_EXTENSIONBMP and IDS_DEFAULT_TOOLHINT are defined in
  //tSXPluginHelper. They are the default Icon and Help String for
  //a tSX Builder plugin. Feel free to change them :)
  tSXPluginHost.ButtonResID := 00002;
  tSXPluginHost.HelpResID   := 00002;
  tsxPlugReturn := tsxPLUG_DONE;
end;

procedure OnLeftClick(var tsxPlugReturn : integer);
//this procedure is called whenever the extension button is left-clicked
//Normally, you would display your main form here
begin
  //Return tsxPLUG_DONE if you do not need to respond to callbacks,
  //tsxPLUG_STAYON if you do.
  DisplayParentedForm(TfrmMain, frmMain);
  tsxPlugReturn := tsxPLUG_STAYON;
end;

procedure OnRightClick;
//this procedure is called whenever the extension button is right-clicked
//Normally used to display a configuration or "About" form.
begin
  { Code to respond to right-button click }
  DisplayParentedForm(TfrmAbout, frmAbout);
end;

procedure OnDeactivate;
//this procedure is called when the extension is being deactivated.
//occurs when tsxForceLeftClick is called, or when another tool is selected.
//this will only be called if OnLeftClick returns tsxPLUG_STAYON
//use it for "clean-up" routines
begin
  { Code to respond to plugin deactivation }
  //disenable selection callback
  tsxSelectionChangedCB(tSXPluginHost.tsxID, nil);
  //Close Main Form
  if Assigned(frmMain) and
    not frmMain.Closing then
      frmMain.Close;
end;

procedure OnProcessAttach;
//this procedure is called when the extension Dll is loaded into the
//host application (which *should* be truespace =). You can use it to
//initialize global variables, or even display a splash screen.
begin
  { Code to respond to plugin loading }
end;

procedure OnProcessDetach;
//this procedure is called when the extension Dll is unloaded from memory.
//You can use it to finalize anything your plugin does (like deallocate memory,
//or unregister callbacks, etc.). This WILL be called, even if OnDeactivate is not.
begin
  { Code to respond to plugin unloading }
end;

procedure OnThreadAttach;
//this procedure is called when the extension Dll creates a new thread. Use your
//imagination for the utility of this one...
// WARNING!!! You CANNOT expect an OnThreadAttach call for every
// OnThreadDetach call! They do not necessarily come in pairs!
begin
  { Code to respond to plugin thread attachment }
end;

procedure OnThreadDetach;
//this procedure is called when the extension Dll terminates a thread. Use your
//imagination for the utility of this one...
// WARNING!!! You CANNOT expect an OnThreadAttach call for every
// OnThreadDetach call! They do not necessarily come in pairs!
begin
  { Code to respond to plugin thread detachment }
end;

begin
  //These hook the above procedures into the tSX API... don't change
  //them unless you REALLY know what you are doing.
  DLLProc := @DllMain; //attach the DLL entry/exit points
  DllMain(dll_Process_Startup); //initialize the global host object

  //initialize the global host methods
  tSXPluginHelper.tSXPluginHost.OnGetData       := OnGetData;
  tSXPluginHelper.tSXPluginHost.OnLeftClick     := OnLeftClick;
  tSXPluginHelper.tSXPluginHost.OnRightClick    := OnRightClick;
  tSXPluginHelper.tSXPluginHost.OnDeactivate    := OnDeactivate;
  tSXPluginHelper.tSXPluginHost.OnProcessAttach := OnProcessAttach;
  tSXPluginHelper.tSXPluginHost.OnProcessDetach := OnProcessDetach;
  tSXPluginHelper.tSXPluginHost.OnThreadAttach  := OnThreadAttach;
  tSXPluginHelper.tSXPluginHost.OnThreadDetach  := OnThreadDetach;

  DllMain(dll_Process_Attach); //we are attaching the process
end.

