Unit tSXWiz;

interface

uses
  ShareMem,
  Windows,
  ExptIntf;

{$R STRINGS.RES}
{$R tsx_icons.RES}

type
  TtsxFormExpert = class(TIExpert)
    function GetName: string; override;
    function GetAuthor: string; override;
    function GetComment: string; override;
    function GetPage: string; override;
    function GetGlyph: HICON; override;
    function GetStyle: TExpertStyle; override;
    function GetState: TExpertState; override;
    function GetIDString: string; override;
    function GetMenuText: string; override;
    procedure Execute; override;
  end;

  TtsxExpert = class(TIExpert)
    function GetName: string; override;
    function GetAuthor: string; override;
    function GetComment: string; override;
    function GetPage: string; override;
    function GetGlyph: HICON; override;
    function GetStyle: TExpertStyle; override;
    function GetState: TExpertState; override;
    function GetIDString: string; override;
    function GetMenuText: string; override;
    procedure Execute; override;
  end;

implementation

uses
  ToolIntf,
  VirtIntf,
  tsxDlg,
  tsxAPP,
  dialogs;

procedure HandleException;
begin
   if Assigned(ToolServices) then
     ToolServices.RaiseException(ReleaseException);
end;

{ TtsxFormExpert }
function TtsxFormExpert.GetName: string;
begin
  try
    Result := 'tSX Form Wizard';
  except
    HandleException;
  end;
end;

function TtsxFormExpert.GetComment: string;
begin
  try
    Result := 'trueSpace eXtension Form Wizard from tSX Builder';
  except
    HandleException;
  end;
end;

function TtsxFormExpert.GetGlyph: HICON;
begin
  try
    Result := LoadIcon(HInstance, 'TSXFRMEXPT'); 
  except
    Result := 0;
    HandleException;
  end;
end;

function TtsxFormExpert.GetStyle: TExpertStyle;
begin
  Result := esForm;
end;

function TtsxFormExpert.GetState: TExpertState;
begin
  Result := [esEnabled];
end;

function TtsxFormExpert.GetIDString: string;
begin
  try
    Result := 'LevDataSys.TtsxFormExpert';
  except
    HandleException;
  end;
end;

function TtsxFormExpert.GetAuthor: string;
begin
  try
    Result := 'Leverage Data Systems, Inc.';
  except
    HandleException;
  end;
end;

function TtsxFormExpert.GetPage: string;
begin
  try
    Result := 'tSX Builder';
  except
    HandleException;
  end;
end;

procedure TtsxFormExpert.Execute;
begin
  try
    tSXFormExpert;
  except
    HandleException;
  end;
end;

function TtsxFormExpert.GetMenuText: string;
begin
  try
    Result := 'tSX Form Wizard';
  except
    HandleException;
  end;
end;

{ TtsxExpert }
function TtsxExpert.GetName: string;
begin
  try
    Result := 'tSX Extension Wizard';
  except
    HandleException;
  end;
end;

function TtsxExpert.GetComment: string;
begin
  try
    Result := 'trueSpace eXtension Wizard from tSX Builder';
  except
    HandleException;
  end;
end;

function TtsxExpert.GetGlyph: HICON;
begin
  try
    Result := LoadIcon(HInstance, 'TSXEXPT');
  except
    Result := 0;
    HandleException;
  end;
end;

function TtsxExpert.GetStyle: TExpertStyle;
begin
  Result := esProject;
end;

function TtsxExpert.GetState: TExpertState;
begin
  Result := [esEnabled];
end;

function TtsxExpert.GetIDString: string;
begin
  try
    Result := 'LevDataSys.TtsxExpert';
  except
    HandleException;
  end;
end;

function TtsxExpert.GetAuthor: string;
begin
  try
    Result := 'Leverage Data Systems, Inc.';
  except
    HandleException;
  end;
end;

function TtsxExpert.GetPage: string;
begin
  try
    Result := 'tSX Builder';
  except
    HandleException;
  end;
end;

procedure TtsxExpert.Execute;
begin
  try
    tSXExpert;
  except
    HandleException;
  end;
end;

function TtsxExpert.GetMenuText: string;
begin
  try
    Result := 'tSX Form Wizard';
  except
    HandleException;
  end;
end;

end.
