unit tsxApp;

interface

uses
  ShareMem,
  SysUtils, Windows, Messages, Classes, Graphics, Controls,
  Forms, Dialogs, ToolIntf, StdCtrls, Buttons, ExtCtrls, ComCtrls, ExptIntf;

type
  TMoveDirection = (mdNoMove, mdPrevious, mdNext);

  TtsxPluginExpert = class(TForm)
    CancelBtn: TButton;
    PrevButton: TButton;
    NextButton: TButton;
    PageControl: TPageControl;
    Properties: TTabSheet;
    tSXInfo: TTabSheet;
    Label13: TLabel;
    Label10: TLabel;
    Label15: TLabel;
    AppPath: TEdit;
    PathBrowse: TButton;
    AppName: TEdit;
    Label1: TLabel;
    Title: TEdit;
    Author: TEdit;
    Label2: TLabel;
    Label3: TLabel;
    Label4: TLabel;
    Label5: TLabel;
    Panel1: TPanel;
    Image1: TImage;
    procedure FormCreate(Sender: TObject);
    procedure NextPrevClick(Sender: TObject);
    procedure BrowseClick(Sender: TObject);
  private
    { Private declarations }
    procedure RefreshButtons;
    function NextPage(Direction: TMoveDirection): Integer;
    function ValidateInfo: Boolean;
  public
    { Public declarations }
  end;
var
  tsxPluginExpert: TtsxPluginExpert;

procedure tSXExpert;

implementation

uses ExConst, FileCtrl;

{$R *.DFM}

{ Code generation support }
const
  SourceBufferSize = 1024;

var
  SourceBuffer: PChar;

procedure WriteProjectLines(AppName, AppTitle, AppAuthor: string);
var
  tmpPChar : PChar;
begin
  tmpPChar := 'Library %s;' + #13#10 +
              '//*********************************************//' + #13#10 +
              '//                                             //' + #13#10 +
              '//  trueSpace eXtension                        //' + #13#10 +
              '//                                             //' + #13#10 +
              '//*********************************************//' + #13#10#13#10 +
              'uses Classes,' + #13#10 +
              '  SysUtils,' + #13#10 +
              '  windows,' + #13#10 +
              '  tsxTypes,' + #13#10 +
              '  tsxPluginHelper;' + #13#10 +
              '' + #13#10 +
              '{$E tsx}' + #13#10#13#10 +
              'procedure OnGetData(var tsxPlugReturn : integer);' + #13#10 +
              '//this procedure is called on extension intialization' + #13#10 +
              '//Generally just used to provide a button graphic and' + #13#10 +
              '//Help Text string to trueSpace.' + #13#10 +
              'begin' + #13#10 +
              '  //Change these to suit your extension' + #13#10 +
              '  tSXPluginHost.Title       := ''%s'';' + #13#10 +
              '  tSXPluginHost.Author      := ''%s'';' + #13#10 +
              '  //These are the resource IDs of any bitmap and string resource' + #13#10 +
              '  //IDB_DEFAULT_EXTENSIONBMP and IDS_DEFAULT_TOOLHINT are defined in' + #13#10 +
              '  //tSXPluginHelper. They are the default Icon and Help String for' + #13#10 +
              '  //a tSX Builder plugin. Feel free to change them :)' + #13#10 +
              '  tSXPluginHost.ButtonResID := IDB_DEFAULT_EXTENSIONBMP;' + #13#10 +
              '  tSXPluginHost.HelpResID   := IDS_DEFAULT_TOOLHINT;' + #13#10 +
              '  tsxPlugReturn := tsxPLUG_DONE;' + #13#10 +
              'end;' + #13#10#13#10 +
              'procedure OnLeftClick(var tsxPlugReturn : integer);' + #13#10 +
              '//this procedure is called whenever the extension button is left-clicked' + #13#10 +
              '//Normally, you would display your main form here' + #13#10 +
              'begin' + #13#10 +
              '  //Return tsxPLUG_DONE if you do not need to respond to callbacks,' + #13#10 +
              '  //tsxPLUG_STAYON if you do.' + #13#10 +
              '  tsxPlugReturn := tsxPLUG_DONE;' + #13#10 +
              'end;' + #13#10#13#10 +
              'procedure OnRightClick;' + #13#10 +
              '//this procedure is called whenever the extension button is right-clicked' + #13#10 +
              '//Normally used to display a configuration or "About" form.' + #13#10 +
              'begin' + #13#10 +
              '  { Code to respond to right-button click }' + #13#10 +
              'end;' + #13#10#13#10 +
              'procedure OnDeactivate;' + #13#10 +
              '//this procedure is called when the extension is being deactivated.' + #13#10 +
              '//occurs when tsxForceLeftClick is called, or when another tool is selected.' + #13#10 +
              '//this will only be called if OnLeftClick returns tsxPLUG_STAYON' + #13#10 +
              '//use it for "clean-up" routines' + #13#10 +
              'begin' + #13#10 +
              '  { Code to respond to plugin deactivation }' + #13#10 +
              'end;' + #13#10#13#10 +
              'procedure OnProcessAttach;' + #13#10 +
              '//this procedure is called when the extension Dll is loaded into the' + #13#10 +
              '//host application (which *should* be truespace =). You can use it to' + #13#10 +
              '//initialize global variables, or even display a splash screen.' + #13#10 +
              'begin' + #13#10 +
              '  { Code to respond to plugin loading }' + #13#10 +
              'end;' + #13#10#13#10 +
              'procedure OnProcessDetach;' + #13#10 +
              '//this procedure is called when the extension Dll is unloaded from memory.' + #13#10 +
              '//You can use it to finalize anything your plugin does (like deallocate memory,' + #13#10 +
              '//or unregister callbacks, etc.). This WILL be called, even if OnDeactivate is not.' + #13#10 +
              'begin' + #13#10 +
              '  { Code to respond to plugin unloading }' + #13#10 +
              'end;' + #13#10#13#10 +
              'procedure OnThreadAttach;' + #13#10 +
              '//this procedure is called when the extension Dll creates a new thread. Use your' + #13#10 +
              '//imagination for the utility of this one...' + #13#10 +
              '// WARNING!!! You CANNOT expect an OnThreadAttach call for every' + #13#10 +
              '// OnThreadDetach call! They do not necessarily come in pairs!' + #13#10 +
              'begin' + #13#10 +
              '  { Code to respond to plugin thread attachment }' + #13#10 +
              'end;' + #13#10#13#10 +
              'procedure OnThreadDetach;' + #13#10 +
              '//this procedure is called when the extension Dll terminates a thread. Use your' + #13#10 +
              '//imagination for the utility of this one...' + #13#10 +
              '// WARNING!!! You CANNOT expect an OnThreadAttach call for every' + #13#10 +
              '// OnThreadDetach call! They do not necessarily come in pairs!' + #13#10 +
              'begin' + #13#10 +
              '  { Code to respond to plugin thread detachment }' + #13#10 +
              'end;' + #13#10#13#10 +
              'begin' + #13#10 +
              '  //These hook the above procedures into the tSX API... don''t change' + #13#10 +
              '  //them unless you REALLY know what you are doing.' + #13#10 +
              '  DLLProc := @DllMain; //attach the DLL entry/exit points' + #13#10 +
              '  DllMain(dll_Process_Startup); //initialize the global host object' + #13#10#13#10 +
              '  //initialize the global host methods' + #13#10 +
              '  tSXPluginHelper.tSXPluginHost.OnGetData    := OnGetData;' + #13#10 +
              '  tSXPluginHelper.tSXPluginHost.OnLeftClick  := OnLeftClick;' + #13#10 +
              '  tSXPluginHelper.tSXPluginHost.OnRightClick := OnRightClick;' + #13#10 +
              '  tSXPluginHelper.tSXPluginHost.OnDeactivate := OnDeactivate;' + #13#10 +
              '  tSXPluginHelper.tSXPluginHost.OnGetData       := OnGetData;' + #13#10 +
              '  tSXPluginHelper.tSXPluginHost.OnLeftClick     := OnLeftClick;' + #13#10 +
              '  tSXPluginHelper.tSXPluginHost.OnRightClick    := OnRightClick;' + #13#10 +
              '  tSXPluginHelper.tSXPluginHost.OnDeactivate    := OnDeactivate;' + #13#10 +
              '  tSXPluginHelper.tSXPluginHost.OnProcessAttach := OnProcessAttach;' + #13#10 +
              '  tSXPluginHelper.tSXPluginHost.OnProcessDetach := OnProcessDetach;' + #13#10 +
              '  tSXPluginHelper.tSXPluginHost.OnThreadAttach  := OnThreadAttach;' + #13#10 +
              '  tSXPluginHelper.tSXPluginHost.OnThreadDetach  := OnThreadDetach;' + #13#10#13#10 +
              '  DllMain(dll_Process_Attach); //we are attaching the process' + #13#10 +
              'end.' + #13#10;
    SourceBuffer := AllocMem(sizeof(char)*(strlen(tmpPChar) + 1 + length(AppName) + length(AppTitle) + length(AppAuthor)));
    StrFmt(SourceBuffer, tmpPChar, [AppName, AppTitle, AppAuthor]);
end;

function GenerateProjectSource(tsxPluginExpert: TtsxPluginExpert): TFileName;
var
  ProjectFile: TFileStream;
begin
  Result := tsxPluginExpert.AppPath.Text;
  if (Result > '') and not (AnsiLastChar(Result)^ in [':', '\']) then
    Result := Result + '\';
  Result := Result + tsxPluginExpert.AppName.Text + '.DPR';

  ProjectFile := TFileStream.Create(Result, fmCreate);
  try
    WriteProjectLines(tsxPluginExpert.AppName.Text, tsxPluginExpert.Title.Text, tsxPluginExpert.Author.Text);
    ProjectFile.Write(SourceBuffer[0], StrLen(SourceBuffer));
    FreeMem(SourceBuffer);
  finally
    ProjectFile.Free;
  end;
end;

{ interface procedure }
procedure tSXExpert;
var
  ProjectName: TFileName;
begin
  tsxPluginExpert := TtsxPluginExpert.Create(nil{Application});
  try
    if tsxPluginExpert.ShowModal = mrOK then
      begin
      ProjectName := ExpandFileName(GenerateProjectSource(tsxPluginExpert));
      { open the new project }
      if (ToolServices <> nil) then
        if ToolServices.CloseProject then
          ToolServices.OpenProject(ProjectName);
      end;
  finally
    tsxPluginExpert.Free;
  end;
end;

{ TAppExpert }
procedure TtsxPluginExpert.FormCreate(Sender: TObject);
begin
  PageControl.ActivePage := PageControl.Pages[0];
  RefreshButtons;
end;

procedure TtsxPluginExpert.RefreshButtons;
begin
  case NextPage(mdNoMove) of
   -1: NextButton.Caption := LoadStr(sFinish);
    0: NextButton.Caption := LoadStr(sNext);
  end;
  case NextPage(mdPrevious) of
    -2: PrevButton.Enabled := False;
    else PrevButton.Enabled := True;
  end;
end;

function TtsxPluginExpert.ValidateInfo: Boolean;
begin
  Result := False;
  if AppName.Text = '' then
  begin
    MessageDlg('A Plugin Name is required.', mtError, [mbOK], 0);
    Exit;
  end;
  if not IsValidIdent(AppName.Text) then
  begin
    MessageDlg('You must specify a valid Plugin Name. Spaces' +
      #10#13 + 'and most punctuation are not permitted.', mtError, [mbOK], 0);
    Exit;
  end;
  if not DirectoryExists(AppPath.Text) then
  begin
    MessageDlg('The path entered does not exist.', mtError, [mbOK], 0);
    Exit;
  end;
  Result := True;
end;

function TtsxPluginExpert.NextPage(Direction: TMoveDirection): Integer;
var
  CurPage: Integer;
begin
  Result := -2;
  CurPage := PageControl.ActivePage.PageIndex;

  case Direction of
    mdNoMove  : if CurPage = 1 then Result := -1
                  else Result := 0;
    mdPrevious: if CurPage = 1 then Result := 0;
    mdNext    : begin
                if CurPage = 0 then Result := 1;
                if CurPage = 1 then Result := -1;
                end;
  end;
end;

procedure TtsxPluginExpert.NextPrevClick(Sender: TObject);
var
  NewPage: Integer;
begin
  if Sender = PrevButton then NewPage := NextPage(mdPrevious)
  else NewPage := NextPage(mdNext);

  case NewPage of
   -1: if ValidateInfo then ModalResult := mrOK;
   -2: begin { do nothing } end;
    else
      PageControl.ActivePage := PageControl.Pages[NewPage];
  end;
  RefreshButtons;
end;

procedure TtsxPluginExpert.BrowseClick(Sender: TObject);
var
  D: string;
begin
  D := AppPath.Text;
  if SelectDirectory(D, [sdAllowCreate, sdPrompt, sdPerformCreate], 0) then
    AppPath.Text := D;
end;


end.
